:- [identifier, set_list].

% daug_a_integer -->
% 	a_integer,
% 	daug_arba_nulis_a_integer.

% some_or_none_a_integer -->
% 	a_integer,
% 	some_or_none_a_integer.

% some_or_none_a_integer -->
% 	[].
	
% a_integer -->
% 	a,
% 	digit,
% 	digits.

% digits -->
%         digit, !,
%         digits.
% digits -->
%         [].

% digit -->
%         [D],
%         { code_type(D, digit)
%         }.

% a -->
% 	[A],
% 	{ char_code('a', A)
% 	}.

sets_not_recur(Sets) :-
	sets_recur(Sets), !,
	fail.

sets_not_recur(_).


sets_recur([Key|_]) :-
	set_recur(Key).

sets_recur([_|Remainder]) :-
	sets_recur(Remainder).

% compare set Key1 with all sets Key2
% where <a<Int>(a<Int>(...(Key2))) == Key1
set_recur(Key1) :-
	Key1 =.. [_, Key2],
 	set_recur(Key1, Key2).

set_recur(Key1, Key2) :-
	sets_identical4(Key1, Key2), !.

set_recur(Key1, Key2) :-
	Key2 =.. [_, Key3],
	set_recur(Key1, Key3).

sets_identical(Key1, Key2) :-
	flag(number_of_elements, _, -1), %we have to subtract recorded count(_)
	count_if_needed(Key1),
	count_if_needed(Key2),
	recorded(Key1, Formula),
	recorded(Key2, Formula),
	flag(number_of_elements, Count, Count + 1),
	fail.

sets_identical(Key1, Key2) :-
	flag(number_of_elements, Count, Count),
	recorded(Key1, count(Count)),
	recorded(Key2, count(Count)).

sets_identical2(Key1, Key2) :-
	get_set_identifier(Key1, ID),
	get_set_identifier(Key2, ID).

sets_identical3(Key1, Key2) :-
	get_list_of_set(Key1, List), %List is returned sorted
	get_list_of_set(Key2, List).

sets_identical4(Key1, Key2) :-
	get_count_of_formulae(Key1, Count),
	get_count_of_formulae(Key2, Count),
	sets_identical3(Key1, Key2).


get_count_of_formulae(Key, Count) :-
	recorded(Key, count(Tmp)),
	!,
	Count is Tmp.

get_count_of_formulae(Key, _) :-
	flag(get_count_of_formulae, _, 0),
	recorded(Key, _),
	% we should check if it is a system info
	flag(get_count_of_formulae, Count, Count + 1),
	fail.

get_count_of_formulae(Key, Count) :-
	flag(get_count_of_formulae, Count, Count),
	recorda(Key, count(Count)),
	!,
	Count is Count.

count_if_needed(Key) :-
	recorded(Key, count(_)),
	!.

count_if_needed(Key) :-
	flag(count_if_needed, _, 0),
	recorded(Key, _),
	flag(count_if_needed, Count, Count + 1),
	fail.

count_if_needed(Key) :-
	flag(count_if_needed, Count, Count),
	recorda(Key, count(Count)),
	!.

system_info(count(_)).
system_info(id(_)).
system_info(list(_)).

not_system_info(Formula) :-
	system_info(Formula), !,
	fail.

not_system_info(_).