				% Theorem prover for S4Dio
				% Written by
				%    Stanislovas Norgela
				%    Laumingis Skripkauskas

:- module(s4d,
	  [s4d/1	% +Formula
	   ]).

:- [operators, dissolve, axioms, rules, sequents].

s4d(Formula) :-
	dissolve(Formula),	%should return the name of the sequent: dissolve
	sequent_derivable(dissolve).


sequent_derivable(Sequent) :-
	axiom_valid(Sequent),
	remove_sequent(Sequent). %clear

sequent_derivable(Sequent) :-
	recorded(Sequent, Formula),
	apply_rules(Formula, Sequent, Branches),
	sequents_derivable(Branches),
	remove_sequent(Sequent). %clear

% necessary to clear
sequent_derivable(Sequent) :-
	remove_sequent(Sequent), %clear
	fail.


sequents_derivable([Sequent|Remainder]) :-
	sequent_derivable(Sequent) ->
	sequents_derivable(Remainder)
	; (
	    remove_sequents(Remainder),
	    fail
	  ).

sequents_derivable([]).

