:- [gensym_simple].

copy_with_always(From, To) :-
	recorded(From, Formula),
	Formula =.. [always, _],
	recorda(To, Formula),
	fail.

copy_with_always(_, _).

copy(From, To) :-
	recorded(From, Formula),
	not_system_info(Formula),
	recorda(To, Formula),
	fail.

copy(_, _).

remove(Sequent, Formula) :-
	recorded(Sequent, Formula, Reference),
	erase(Reference).

remove_sequent(Sequent) :-
	recorded(Sequent, _, Reference),
	erase(Reference),
	fail.

remove_sequent(Sequent) :-
	Sequent =.. [Atom, _],
	release_unique_symbol(Atom).

% if Sequent =.. [_, _] fails
remove_sequent(_).

remove_sequents([]).

remove_sequents([Sequent|Remainder]) :-
	remove_sequent(Sequent),
	remove_sequents(Remainder).

print_sequent(Sequent) :-
	write('Sequent '),
	write(Sequent),
	writeln(':'),
	recorded(Sequent, Formula),
	writeln(Formula),
	fail.

print_sequent :-
	writeln('').


supplement_sequent(Sequent, Formula) :-
	recorded(Sequent, Formula), !.

supplement_sequent(Sequent, Formula) :-
	recorda(Sequent, Formula).

